import { Bits } from "../utils/Bits";
import { ComponentClass } from "./Component";
import { Entity } from "./Entity";
declare class Builder {
    private static instance;
    private _all;
    private _one;
    private _exclude;
    constructor();
    reset(): Builder;
    all(...componentTypes: ComponentClass[]): Builder;
    one(...componentTypes: ComponentClass[]): Builder;
    exclude(...componentTypes: ComponentClass[]): Builder;
    get(): Family;
}
export declare class Family {
    private readonly all;
    private readonly one;
    private readonly exclude;
    private static readonly families;
    private static readonly builder;
    static readonly zeroBits: Bits;
    private static familyIndex;
    private index;
    protected constructor(all: Bits, one: Bits, exclude: Bits);
    /** @return Соответствует ли объект семейным требованиям или нет */
    matches(entity: Entity): boolean;
    /** Возвращает hash code  в числовом формате */
    hashCode(): number;
    /** @return Уникальный индекс этого семейства */
    getIndex(): number;
    /** Сравнивает объект семейства */
    equals(object: object): boolean;
    getFamilyHash(): number;
    static create(all: Bits, one: Bits, exclude: Bits): Family;
    /**
     * @param componentTypes сущности должны будут содержать все указанные компоненты.
     * @return Builder singleton для получения семейства
     */
    static all(...componentTypes: ComponentClass[]): Builder;
    /**
     * @param componentTypes объекты должны содержать хотя бы один из указанных компонентов.
     * @return Builder singleton для получения семейства
     */
    static one(...componentTypes: ComponentClass[]): Builder;
    /**
     * @param componentTypes объекты не могут содержать ни один из указанных компонентов.
     * @return Builder singleton для получения семейства
     */
    static exclude(...componentTypes: ComponentClass[]): Builder;
}
export {};
