import { Listener } from "./Listener";
export declare class Signal<T> {
    private listeners;
    constructor();
    /**
     * Добавьте слушателя к этому сигналу
     * @param listener Добавляемый слушатель
     */
    add(listener: Listener<T>): void;
    /**
     * Удалить слушателя из этого сигнала
     * @param listener Слушатель, который нужно удалить
     */
    remove(listener: Listener<T>): void;
    /** Удаляет всех прослушивателей, прикрепленных к this {@link Signal}. */
    removeAllListeners(): void;
    /**
     * Отправляет событие всем слушателям, зарегистрированным на этот сигнал
     * @param object Объект для отправки
     */
    dispatch(object: T): void;
}
