export declare class Handbag<E> {
    private data;
    private _size;
    constructor(capacity?: number);
    /**
     * Удаляет элемент в указанной позиции в этой сумке. Порядок элементов не сохраняется.
     * @return, удаленный елемент.
     */
    remove(index: number): E | null;
    /**
     * Удаляет первое вхождение указанного элемента из сумки, если он присутствует. не сохраняет порядок элементов.
     * @return true, если элемент был удален.
     */
    removeByItem(e: E): boolean;
    /**
     * Проверьте, есть ли в сумке этот элемент. Оператор === используется для
     * проверки на равенство.
     */
    contains(e: E): boolean;
    /**
     * @return элемент в указанной позиции в Сумке.
     */
    get(index: number): E | null;
    /**
     * @return количество элементов в этой сумке.
     */
    size(): number;
    /**
     * @return количество элементов, которые сумка может вместить без увеличения.
     */
    getCapacity(): number;
    /**
     * @param index
     * @return находится ли индекс в пределах коллекции
     */
    isIndexWithinBounds(index: number): boolean;
    /**
     * @return true если сумка пуста
     */
    isEmpty(): boolean;
    /**
     * Добавляет указанный элемент в конец этого пакета. при необходимости также увеличивает вместимость сумки
     */
    add(e: E | null): void;
    /**
       * Установить элемент по указанному индексу в сумке.
       */
    set(index: number, e: E | null): void;
    private grow;
    /**
     *  * Убирает и возвращает последний предмет в сумке.
     * @returns последний предмет в сумке, null, если она пуста.
     */
    removeLast(): E | null;
}
