import { EngineIterable } from "../@interfaces/EngineIterable";
import { EngineObject } from "../@interfaces/EngineObject";
export declare class ImmutableArray<T extends EngineObject> implements EngineIterable<T>, EngineObject {
    private readonly array;
    private index;
    /**
     * Класс - оболочка для массива. Являеться неизменяемым объектом.
     * @param array
     */
    constructor(array: Array<T>);
    size(): number;
    get(index: number): T | null;
    /**
     * Возвращает индекс последнего вхождения заданного значения в массив или -1, если оно отсутствует.
      @param searchElement — Значение, которое нужно найти в массиве.
      @param fromIndex — Индекс массива, с которого начинается поиск в обратном направлении. Если параметр fromIndex опущен, поиск начинается с последнего индекса в массиве.
     */
    lastIndexOf(searchElement: T, fromIndex?: number): number;
    /**
     *
     * @param value
     * @param identity Если true, будет использоваться сравнение ===. Если false, будет использоваться сравнение .equals().
     * (.equals() - не реализован, удалить после реализации)
     */
    contains(value: T, identity?: boolean): boolean;
    /**
     *
     * Возвращает индекс первого вхождения значения в массив или -1, если оно отсутствует.
     * @param searchElement — Значение, которое нужно найти в массиве.
     * @param fromIndex — Индекс массива, с которого начинается поиск. Если параметр fromIndex опущен, поиск начинается с индекса 0.
     * @returns
     */
    indexOf(searchElement: T, fromIndex?: number): number;
    forEach(callback: (item: T) => void): void;
    /**
     * Получить первый элемент коллекции.
     * @returns
     */
    peek(): T;
    /**
     * Получить последний элемент коллекции
     * @returns
     */
    first(): T;
    /**
     * Получить случайный элмент коллекции.
     * @returns
     */
    random(): T;
    /**
     * Получить нативный массив обектов {@link T}
     * @returns
     */
    toArray(): T[];
    toString(): string;
    hashCode(): number;
    equals(object: EngineObject): boolean;
    [Symbol.iterator](): IterableIterator<T>;
}
