import { EngineObject } from "../@interfaces/EngineObject";
/**
 * Не готов.
 */
export declare class IterableArray<T extends EngineObject> implements Iterable<T>, EngineObject {
    private readonly array;
    constructor(array?: Iterable<T>);
    hashCode(): number;
    equals(object: EngineObject): boolean;
    toString(): string;
    /**
     * Получить элемент массива по индексу.
     * @param index - номер индекса с 0.
     * @returns Элемент массива.
     */
    get(index: number): T | null;
    /**
     * удаляет последний элемент из массива и возвращает его значение.
     */
    pop(): T | null;
    /**
     * Метод push() добавляет один или более элементов в конец массива и возвращает новую длину массива.
     * @param items размер массива
     */
    push(...items: T[]): number;
    /**
     * Метод indexOf() возвращает первый индекс, по которому данный элемент может быть найден в массиве или -1, если такого индекса нет.
     * @param searchElement Искомый элемент в массиве.
     */
    indexOf(searchElement: T): number;
    /**
     * Метод lastIndexOf() возвращает индекс последнего вхождения указанного значения в строковый объект String,
     * на котором он был вызван, или -1, если ничего не было найдено.
     * @param searchElement Строка, представляющая искомое значение.
     * @returns number.
     */
    lastIndexOf(searchElement: T): number;
    /**
     * Метод forEach() выполняет указанную функцию один раз для каждого элемента в массиве.
     * currentValue Текущий обрабатываемый элемент в массиве.
     * index Необязательный Индекс текущего обрабатываемого элемента в массиве.
     * array Необязательный Массив, по которому осуществляется проход.
     * @param callbackfn Функция, которая будет вызвана для каждого элемента массива. Она принимает от одного до трёх аргументов:
     */
    forEach(callbackfn: (value: T, index: number, array: T[]) => void): void;
    entries(): IterableIterator<[T, T]>;
    keys(): IterableIterator<T>;
    values(): IterableIterator<T>;
    size(): number;
    [Symbol.iterator](): IterableIterator<T>;
}
